var _a, _b;
import mockFetchOn, { MSWInterceptors, Channel } from './core';
export * from './core';
export { mockFetchOn };
const swSupported = typeof window !== 'undefined' && !!((_a = window === null || window === void 0 ? void 0 : window.navigator) === null || _a === void 0 ? void 0 : _a.serviceWorker);
const isInNode = typeof process !== 'undefined' && ((_b = process === null || process === void 0 ? void 0 : process.release) === null || _b === void 0 ? void 0 : _b.name) === 'node';
let channel;
let mswInterceptors;
let libRestore = () => { };
const onfetch = Object.assign(mockFetchOn(globalThis), {
    useServiceWorker() {
        if (!channel) {
            if (!swSupported) {
                throw new Error('Environment not compatible with service worker mode');
            }
            channel = new Channel(window.navigator.serviceWorker);
        }
        libRestore();
        channel.activate();
        libRestore = channel.restore.bind(channel);
        onfetch.adopt(channel);
        onfetch.config({
            bypassRedirect: true,
        });
    },
    useMSWInterceptors() {
        if (!mswInterceptors) {
            if (!isInNode) {
                throw new Error('Environment not compatible with msw interceptor mode');
            }
            mswInterceptors = new MSWInterceptors();
        }
        libRestore();
        mswInterceptors.activate();
        libRestore = mswInterceptors.restore.bind(mswInterceptors);
        onfetch.adopt(mswInterceptors);
        onfetch.config({
            bypassRedirect: true,
        });
    },
    useAutoAdvanced() {
        if (swSupported) {
            this.useServiceWorker();
        }
        else if (isInNode) {
            this.useMSWInterceptors();
        }
        else {
            throw new Error('Environment not compatible with any advanced mode');
        }
    },
    useDefault() {
        libRestore();
        onfetch.adopt(globalThis);
        onfetch.config({
            bypassRedirect: false,
        });
    },
});
onfetch.activate();
export default onfetch;
