import { FulfillList, RequestMessage, ResponseMessage } from './Message';
/**
 * A fetch receiver
 * - For received requests, message to service worker.
 * - For messaged requests, send to the receiver. <- Intercept here.
 */
export default class Channel {
    port?: MessagePort;
    fulfillList?: FulfillList;
    private beActive;
    constructor(workerContainer: ServiceWorkerContainer);
    private registerController;
    /**
     * For received requests, message to the service worker.
     */
    fetch: (input: RequestInfo, init?: RequestInit | undefined) => Promise<Response>;
    onMessage: (event: MessageEvent) => void;
    /**
     * For messaged requests, send to the receiver.
     */
    onRequestMessage: (event: MessageEvent<RequestMessage>) => Promise<void>;
    /**
     * For messaged responses, treat as a previous received request's response.
     */
    onResponseMessage: (event: MessageEvent<ResponseMessage>) => Promise<void>;
    isActive(): boolean;
    /**
     * Start receiving worker messages.
     */
    activate(): void;
    /**
     * Stop receiving worker messages.
     */
    restore(): void;
}
//# sourceMappingURL=Channel.d.ts.map