async function toCloneable(requestOrResponse) {
    const arrayBuffer = await requestOrResponse.clone().arrayBuffer();
    const body = arrayBuffer.byteLength > 0 ? arrayBuffer : null;
    const headers = [...requestOrResponse.headers];
    // To cloneable request.
    if (requestOrResponse instanceof Request) {
        const { cache, credentials, destination, integrity, keepalive, method, mode, redirect, referrer, referrerPolicy, url, } = requestOrResponse;
        return {
            body,
            cache,
            credentials,
            destination,
            headers,
            integrity,
            keepalive,
            method,
            mode,
            redirect,
            referrer,
            referrerPolicy,
            url,
        };
    }
    // To cloneable response.
    const { ok, redirected, status, statusText, type, url, } = requestOrResponse;
    return {
        body,
        headers,
        ok,
        redirected,
        status,
        statusText,
        type,
        url,
    };
}
export default toCloneable;
